]> git.street.me.uk Git - andy/dehydrated.git/blob - letsencrypt.sh
Pass intermediate cert to hook script
[andy/dehydrated.git] / letsencrypt.sh
1 #!/usr/bin/env bash
2
3 # letsencrypt.sh by lukas2511
4 # Source: https://github.com/lukas2511/letsencrypt.sh
5
6 set -e
7 set -u
8 set -o pipefail
9 [[ -n "${ZSH_VERSION:-}" ]] && set -o SH_WORD_SPLIT && set +o FUNCTION_ARGZERO
10 umask 077 # paranoid umask, we're creating private keys
11
12 # duplicate scripts IO handles
13 exec 4<&0 5>&1 6>&2
14
15 # Find directory in which this script is stored by traversing all symbolic links
16 SOURCE="${0}"
17 while [ -h "$SOURCE" ]; do # resolve $SOURCE until the file is no longer a symlink
18   DIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
19   SOURCE="$(readlink "$SOURCE")"
20   [[ $SOURCE != /* ]] && SOURCE="$DIR/$SOURCE" # if $SOURCE was a relative symlink, we need to resolve it relative to the path where the symlink file was located
21 done
22 SCRIPTDIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
23
24 BASEDIR="${SCRIPTDIR}"
25
26 # Check for script dependencies
27 check_dependencies() {
28   # just execute some dummy and/or version commands to see if required tools exist and are actually usable
29   openssl version > /dev/null 2>&1 || _exiterr "This script requires an openssl binary."
30   _sed "" < /dev/null > /dev/null 2>&1 || _exiterr "This script requires sed with support for extended (modern) regular expressions."
31   grep -V > /dev/null 2>&1 || _exiterr "This script requires grep."
32   mktemp -u -t XXXXXX > /dev/null 2>&1 || _exiterr "This script requires mktemp."
33
34   # curl returns with an error code in some ancient versions so we have to catch that
35   set +e
36   curl -V > /dev/null 2>&1
37   retcode="$?"
38   set -e
39   if [[ ! "${retcode}" = "0" ]] && [[ ! "${retcode}" = "2" ]]; then
40     _exiterr "This script requires curl."
41   fi
42 }
43
44 # Setup default config values, search for and load configuration files
45 load_config() {
46   # Check for config in various locations
47   if [[ -z "${CONFIG:-}" ]]; then
48     for check_config in "/etc/letsencrypt.sh" "/usr/local/etc/letsencrypt.sh" "${PWD}" "${SCRIPTDIR}"; do
49       if [[ -e "${check_config}/config.sh" ]]; then
50         BASEDIR="${check_config}"
51         CONFIG="${check_config}/config.sh"
52         break
53       fi
54     done
55   fi
56
57   # Default values
58   CA="https://acme-v01.api.letsencrypt.org/directory"
59   LICENSE="https://letsencrypt.org/documents/LE-SA-v1.0.1-July-27-2015.pdf"
60   CHALLENGETYPE="http-01"
61   CONFIG_D=
62   HOOK=
63   HOOK_CHAIN="no"
64   RENEW_DAYS="30"
65   PRIVATE_KEY=
66   KEYSIZE="4096"
67   WELLKNOWN=
68   PRIVATE_KEY_RENEW="no"
69   KEY_ALGO=rsa
70   OPENSSL_CNF="$(openssl version -d | cut -d\" -f2)/openssl.cnf"
71   CONTACT_EMAIL=
72   LOCKFILE=
73
74   if [[ -z "${CONFIG:-}" ]]; then
75     echo "#" >&2
76     echo "# !! WARNING !! No main config file found, using default config!" >&2
77     echo "#" >&2
78   elif [[ -e "${CONFIG}" ]]; then
79     echo "# INFO: Using main config file ${CONFIG}"
80     BASEDIR="$(dirname "${CONFIG}")"
81     # shellcheck disable=SC1090
82     . "${CONFIG}"
83   else
84     _exiterr "Specified config file doesn't exist."
85   fi
86
87   if [[ -n "${CONFIG_D}" ]]; then
88     if [[ ! -d "${CONFIG_D}" ]]; then
89       _exiterr "The path ${CONFIG_D} specified for CONFIG_D does not point to a directory." >&2
90     fi
91
92     for check_config_d in ${CONFIG_D}/*.sh; do
93       if [[ ! -e "${check_config_d}" ]]; then
94         echo "# !! WARNING !! Extra configuration directory ${CONFIG_D} exists, but no configuration found in it." >&2
95         break
96       elif [[ -f "${check_config_d}" ]] && [[ -r "${check_config_d}" ]]; then
97         echo "# INFO: Using additional config file ${check_config_d}"
98         . ${check_config_d}
99       else
100         _exiterr "Specified additional config ${check_config_d} is not readable or not a file at all." >&2
101       fi
102    done
103   fi
104
105   # Remove slash from end of BASEDIR. Mostly for cleaner outputs, doesn't change functionality.
106   BASEDIR="${BASEDIR%%/}"
107
108   # Check BASEDIR and set default variables
109   [[ -d "${BASEDIR}" ]] || _exiterr "BASEDIR does not exist: ${BASEDIR}"
110
111   [[ -z "${PRIVATE_KEY}" ]] && PRIVATE_KEY="${BASEDIR}/private_key.pem"
112   [[ -z "${WELLKNOWN}" ]] && WELLKNOWN="${BASEDIR}/.acme-challenges"
113   [[ -z "${LOCKFILE}" ]] && LOCKFILE="${BASEDIR}/lock"
114
115   [[ -n "${PARAM_HOOK:-}" ]] && HOOK="${PARAM_HOOK}"
116   [[ -n "${PARAM_CHALLENGETYPE:-}" ]] && CHALLENGETYPE="${PARAM_CHALLENGETYPE}"
117   [[ -n "${PARAM_KEY_ALGO:-}" ]] && KEY_ALGO="${PARAM_KEY_ALGO}"
118
119   [[ "${CHALLENGETYPE}" =~ (http-01|dns-01) ]] || _exiterr "Unknown challenge type ${CHALLENGETYPE}... can not continue."
120   if [[ "${CHALLENGETYPE}" = "dns-01" ]] && [[ -z "${HOOK}" ]]; then
121    _exiterr "Challenge type dns-01 needs a hook script for deployment... can not continue."
122   fi
123   [[ "${KEY_ALGO}" =~ ^(rsa|prime256v1|secp384r1)$ ]] || _exiterr "Unknown public key algorithm ${KEY_ALGO}... can not continue."
124 }
125
126 # Initialize system
127 init_system() {
128   load_config
129
130   # Lockfile handling (prevents concurrent access)
131   LOCKDIR="$(dirname "${LOCKFILE}")"
132   [[ -w "${LOCKDIR}" ]] || _exiterr "Directory ${LOCKDIR} for LOCKFILE ${LOCKFILE} is not writable, aborting."
133   ( set -C; date > "${LOCKFILE}" ) 2>/dev/null || _exiterr "Lock file '${LOCKFILE}' present, aborting."
134   remove_lock() { rm -f "${LOCKFILE}"; }
135   trap 'remove_lock' EXIT
136
137   # Get CA URLs
138   CA_DIRECTORY="$(http_request get "${CA}")"
139   CA_NEW_CERT="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value new-cert)" &&
140   CA_NEW_AUTHZ="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value new-authz)" &&
141   CA_NEW_REG="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value new-reg)" &&
142   # shellcheck disable=SC2015
143   CA_REVOKE_CERT="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value revoke-cert)" ||
144   _exiterr "Problem retrieving ACME/CA-URLs, check if your configured CA points to the directory entrypoint."
145
146   # Export some environment variables to be used in hook script
147   export WELLKNOWN BASEDIR CONFIG
148
149   # Checking for private key ...
150   register_new_key="no"
151   if [[ -n "${PARAM_PRIVATE_KEY:-}" ]]; then
152     # a private key was specified from the command line so use it for this run
153     echo "Using private key ${PARAM_PRIVATE_KEY} instead of account key"
154     PRIVATE_KEY="${PARAM_PRIVATE_KEY}"
155   else
156     # Check if private account key exists, if it doesn't exist yet generate a new one (rsa key)
157     if [[ ! -e "${PRIVATE_KEY}" ]]; then
158       echo "+ Generating account key..."
159       _openssl genrsa -out "${PRIVATE_KEY}" "${KEYSIZE}"
160       register_new_key="yes"
161     fi
162   fi
163   openssl rsa -in "${PRIVATE_KEY}" -check 2>/dev/null > /dev/null || _exiterr "Private key is not valid, can not continue."
164
165   # Get public components from private key and calculate thumbprint
166   pubExponent64="$(openssl rsa -in "${PRIVATE_KEY}" -noout -text | grep publicExponent | grep -oE "0x[a-f0-9]+" | cut -d'x' -f2 | hex2bin | urlbase64)"
167   pubMod64="$(openssl rsa -in "${PRIVATE_KEY}" -noout -modulus | cut -d'=' -f2 | hex2bin | urlbase64)"
168
169   thumbprint="$(printf '{"e":"%s","kty":"RSA","n":"%s"}' "${pubExponent64}" "${pubMod64}" | openssl dgst -sha256 -binary | urlbase64)"
170
171   # If we generated a new private key in the step above we have to register it with the acme-server
172   if [[ "${register_new_key}" = "yes" ]]; then
173     echo "+ Registering account key with letsencrypt..."
174     [[ ! -z "${CA_NEW_REG}" ]] || _exiterr "Certificate authority doesn't allow registrations."
175     # If an email for the contact has been provided then adding it to the registration request
176     if [[ -n "${CONTACT_EMAIL}" ]]; then
177       signed_request "${CA_NEW_REG}" '{"resource": "new-reg", "contact":["mailto:'"${CONTACT_EMAIL}"'"], "agreement": "'"$LICENSE"'"}' > /dev/null
178     else
179       signed_request "${CA_NEW_REG}" '{"resource": "new-reg", "agreement": "'"$LICENSE"'"}' > /dev/null
180     fi
181   fi
182
183   if [[ "${CHALLENGETYPE}" = "http-01" && ! -d "${WELLKNOWN}" ]]; then
184       _exiterr "WELLKNOWN directory doesn't exist, please create ${WELLKNOWN} and set appropriate permissions."
185   fi
186 }
187
188 # Different sed version for different os types...
189 _sed() {
190   if [[ "${OSTYPE}" = "Linux" ]]; then
191     sed -r "${@}"
192   else
193     sed -E "${@}"
194   fi
195 }
196
197 # Print error message and exit with error
198 _exiterr() {
199   echo "ERROR: ${1}" >&2
200   exit 1
201 }
202
203 # Encode data as url-safe formatted base64
204 urlbase64() {
205   # urlbase64: base64 encoded string with '+' replaced with '-' and '/' replaced with '_'
206   openssl base64 -e | tr -d '\n\r' | _sed -e 's:=*$::g' -e 'y:+/:-_:'
207 }
208
209 # Convert hex string to binary data
210 hex2bin() {
211   # Remove spaces, add leading zero, escape as hex string and parse with printf
212   printf -- "$(cat | _sed -e 's/[[:space:]]//g' -e 's/^(.(.{2})*)$/0\1/' -e 's/(.{2})/\\x\1/g')"
213 }
214
215 # Get string value from json dictionary
216 get_json_string_value() {
217   grep -Eo '"'"${1}"'":[[:space:]]*"[^"]*"' | cut -d'"' -f4
218 }
219
220 # OpenSSL writes to stderr/stdout even when there are no errors. So just
221 # display the output if the exit code was != 0 to simplify debugging.
222 _openssl() {
223   set +e
224   out="$(openssl "${@}" 2>&1)"
225   res=$?
226   set -e
227   if [[ ${res} -ne 0 ]]; then
228     echo "  + ERROR: failed to run $* (Exitcode: ${res})" >&2
229     echo >&2
230     echo "Details:" >&2
231     echo "${out}" >&2
232     echo >&2
233     exit ${res}
234   fi
235 }
236
237 # Send http(s) request with specified method
238 http_request() {
239   tempcont="$(mktemp -t XXXXXX)"
240
241   set +e
242   if [[ "${1}" = "head" ]]; then
243     statuscode="$(curl -s -w "%{http_code}" -o "${tempcont}" "${2}" -I)"
244     curlret="${?}"
245   elif [[ "${1}" = "get" ]]; then
246     statuscode="$(curl -s -w "%{http_code}" -o "${tempcont}" "${2}")"
247     curlret="${?}"
248   elif [[ "${1}" = "post" ]]; then
249     statuscode="$(curl -s -w "%{http_code}" -o "${tempcont}" "${2}" -d "${3}")"
250     curlret="${?}"
251   else
252     set -e
253     _exiterr "Unknown request method: ${1}"
254   fi
255   set -e
256
257   if [[ ! "${curlret}" = "0" ]]; then
258     _exiterr "Problem connecting to server (curl returned with ${curlret})"
259   fi
260
261   if [[ ! "${statuscode:0:1}" = "2" ]]; then
262     echo "  + ERROR: An error occurred while sending ${1}-request to ${2} (Status ${statuscode})" >&2
263     echo >&2
264     echo "Details:" >&2
265     cat "${tempcont}" >&2
266     rm -f "${tempcont}"
267
268     # Wait for hook script to clean the challenge if used
269     if [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" != "yes" ]] && [[ -n "${challenge_token:+set}" ]]; then
270       "${HOOK}" "clean_challenge" '' "${challenge_token}" "${keyauth}" <&4 >&5 2>&6
271     fi
272
273     # remove temporary domains.txt file if used
274     [[ -n "${PARAM_DOMAIN:-}" && -n "${DOMAINS_TXT:-}" ]] && rm "${DOMAINS_TXT}"
275     exit 1
276   fi
277
278   cat "${tempcont}"
279   rm -f "${tempcont}"
280 }
281
282 # Send signed request
283 signed_request() {
284   # Encode payload as urlbase64
285   payload64="$(printf '%s' "${2}" | urlbase64)"
286
287   # Retrieve nonce from acme-server
288   nonce="$(http_request head "${CA}" | grep Replay-Nonce: | awk -F ': ' '{print $2}' | tr -d '\n\r')"
289
290   # Build header with just our public key and algorithm information
291   header='{"alg": "RS256", "jwk": {"e": "'"${pubExponent64}"'", "kty": "RSA", "n": "'"${pubMod64}"'"}}'
292
293   # Build another header which also contains the previously received nonce and encode it as urlbase64
294   protected='{"alg": "RS256", "jwk": {"e": "'"${pubExponent64}"'", "kty": "RSA", "n": "'"${pubMod64}"'"}, "nonce": "'"${nonce}"'"}'
295   protected64="$(printf '%s' "${protected}" | urlbase64)"
296
297   # Sign header with nonce and our payload with our private key and encode signature as urlbase64
298   signed64="$(printf '%s' "${protected64}.${payload64}" | openssl dgst -sha256 -sign "${PRIVATE_KEY}" | urlbase64)"
299
300   # Send header + extended header + payload + signature to the acme-server
301   data='{"header": '"${header}"', "protected": "'"${protected64}"'", "payload": "'"${payload64}"'", "signature": "'"${signed64}"'"}'
302
303   http_request post "${1}" "${data}"
304 }
305
306 # Extracts all subject names from a CSR
307 # Outputs either the CN, or the SANs, one per line
308 extract_altnames() {
309   csr="${1}" # the CSR itself (not a file)
310
311   if ! <<<"${csr}" openssl req -verify -noout 2>/dev/null; then
312     _exiterr "Certificate signing request isn't valid"
313   fi
314
315   reqtext="$( <<<"${csr}" openssl req -noout -text )"
316   if <<<"${reqtext}" grep -q '^[[:space:]]*X509v3 Subject Alternative Name:[[:space:]]*$'; then
317     # SANs used, extract these
318     altnames="$( <<<"${reqtext}" grep -A1 '^[[:space:]]*X509v3 Subject Alternative Name:[[:space:]]*$' | tail -n1 )"
319     # split to one per line:
320     altnames="$( <<<"${altnames}" _sed -e 's/^[[:space:]]*//; s/, /\'$'\n''/g' )"
321     # we can only get DNS: ones signed
322     if [ -n "$( <<<"${altnames}" grep -v '^DNS:' )" ]; then
323       _exiterr "Certificate signing request contains non-DNS Subject Alternative Names"
324     fi
325     # strip away the DNS: prefix
326     altnames="$( <<<"${altnames}" _sed -e 's/^DNS://' )"
327     echo "${altnames}"
328
329   else
330     # No SANs, extract CN
331     altnames="$( <<<"${reqtext}" grep '^[[:space:]]*Subject:' | _sed -e 's/.* CN=([^ /,]*).*/\1/' )"
332     echo "${altnames}"
333   fi
334 }
335
336 # Create certificate for domain(s) and outputs it FD 3
337 sign_csr() {
338   csr="${1}" # the CSR itself (not a file)
339
340   if { true >&3; } 2>/dev/null; then
341     : # fd 3 looks OK
342   else
343     _exiterr "sign_csr: FD 3 not open"
344   fi
345
346   shift 1 || true
347   altnames="${*:-}"
348   if [ -z "${altnames}" ]; then
349     altnames="$( extract_altnames "${csr}" )"
350   fi
351
352   if [[ -z "${CA_NEW_AUTHZ}" ]] || [[ -z "${CA_NEW_CERT}" ]]; then
353     _exiterr "Certificate authority doesn't allow certificate signing"
354   fi
355
356   local idx=0
357   if [[ -n "${ZSH_VERSION:-}" ]]; then
358     local -A challenge_uris challenge_tokens keyauths deploy_args
359   else
360     local -a challenge_uris challenge_tokens keyauths deploy_args
361   fi
362
363   # Request challenges
364   for altname in ${altnames}; do
365     # Ask the acme-server for new challenge token and extract them from the resulting json block
366     echo " + Requesting challenge for ${altname}..."
367     response="$(signed_request "${CA_NEW_AUTHZ}" '{"resource": "new-authz", "identifier": {"type": "dns", "value": "'"${altname}"'"}}')"
368
369     challenges="$(printf '%s\n' "${response}" | grep -Eo '"challenges":[^\[]*\[[^]]*]')"
370     repl=$'\n''{' # fix syntax highlighting in Vim
371     challenge="$(printf "%s" "${challenges//\{/${repl}}" | grep \""${CHALLENGETYPE}"\")"
372     challenge_token="$(printf '%s' "${challenge}" | get_json_string_value token | _sed 's/[^A-Za-z0-9_\-]/_/g')"
373     challenge_uri="$(printf '%s' "${challenge}" | get_json_string_value uri)"
374
375     if [[ -z "${challenge_token}" ]] || [[ -z "${challenge_uri}" ]]; then
376       _exiterr "Can't retrieve challenges (${response})"
377     fi
378
379     # Challenge response consists of the challenge token and the thumbprint of our public certificate
380     keyauth="${challenge_token}.${thumbprint}"
381
382     case "${CHALLENGETYPE}" in
383       "http-01")
384         # Store challenge response in well-known location and make world-readable (so that a webserver can access it)
385         printf '%s' "${keyauth}" > "${WELLKNOWN}/${challenge_token}"
386         chmod a+r "${WELLKNOWN}/${challenge_token}"
387         keyauth_hook="${keyauth}"
388         ;;
389       "dns-01")
390         # Generate DNS entry content for dns-01 validation
391         keyauth_hook="$(printf '%s' "${keyauth}" | openssl dgst -sha256 -binary | urlbase64)"
392         ;;
393     esac
394
395     challenge_uris[${idx}]="${challenge_uri}"
396     keyauths[${idx}]="${keyauth}"
397     challenge_tokens[${idx}]="${challenge_token}"
398     # Note: assumes args will never have spaces!
399     deploy_args[${idx}]="${altname} ${challenge_token} ${keyauth_hook}"
400     idx=$((idx+1))
401   done
402
403   # Wait for hook script to deploy the challenges if used
404   [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" = "yes" ]] && "${HOOK}" "deploy_challenge" ${deploy_args[@]} <&4 >&5 2>&6
405
406   # Respond to challenges
407   idx=0
408   for altname in ${altnames}; do
409     challenge_token="${challenge_tokens[${idx}]}"
410     keyauth="${keyauths[${idx}]}"
411
412     # Wait for hook script to deploy the challenge if used
413     [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" != "yes" ]] && "${HOOK}" "deploy_challenge" ${deploy_args[${idx}]} <&4 >&5 2>&6
414
415     # Ask the acme-server to verify our challenge and wait until it is no longer pending
416     echo " + Responding to challenge for ${altname}..."
417     result="$(signed_request "${challenge_uris[${idx}]}" '{"resource": "challenge", "keyAuthorization": "'"${keyauth}"'"}')"
418
419     reqstatus="$(printf '%s\n' "${result}" | get_json_string_value status)"
420
421     while [[ "${reqstatus}" = "pending" ]]; do
422       sleep 1
423       result="$(http_request get "${challenge_uris[${idx}]}")"
424       reqstatus="$(printf '%s\n' "${result}" | get_json_string_value status)"
425     done
426
427     [[ "${CHALLENGETYPE}" = "http-01" ]] && rm -f "${WELLKNOWN}/${challenge_token}"
428
429     # Wait for hook script to clean the challenge if used
430     if [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" != "yes" ]] && [[ -n "${challenge_token}" ]]; then
431       "${HOOK}" "clean_challenge" ${deploy_args[${idx}]} <&4 >&5 2>&6
432     fi
433     idx=$((idx+1))
434
435     if [[ "${reqstatus}" = "valid" ]]; then
436       echo " + Challenge is valid!"
437     else
438       break
439     fi
440   done
441
442   # Wait for hook script to clean the challenges if used
443   [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" = "yes" ]] && "${HOOK}" "clean_challenge" ${deploy_args[@]}
444
445   if [[ "${reqstatus}" != "valid" ]]; then
446     # Clean up any remaining challenge_tokens if we stopped early
447     if [[ "${CHALLENGETYPE}" = "http-01" ]]; then
448       while [ ${idx} -lt ${#challenge_tokens[@]} ]; do
449         rm -f "${WELLKNOWN}/${challenge_tokens[${idx}]}"
450         idx=$((idx+1))
451       done
452     fi
453
454     _exiterr "Challenge is invalid! (returned: ${reqstatus}) (result: ${result})"
455   fi
456
457   # Finally request certificate from the acme-server and store it in cert-${timestamp}.pem and link from cert.pem
458   echo " + Requesting certificate..."
459   csr64="$( <<<"${csr}" openssl req -outform DER | urlbase64)"
460   crt64="$(signed_request "${CA_NEW_CERT}" '{"resource": "new-cert", "csr": "'"${csr64}"'"}' | openssl base64 -e)"
461   crt="$( printf -- '-----BEGIN CERTIFICATE-----\n%s\n-----END CERTIFICATE-----\n' "${crt64}" )"
462
463   # Try to load the certificate to detect corruption
464   echo " + Checking certificate..."
465   _openssl x509 -text <<<"${crt}"
466
467   echo "${crt}" >&3
468
469   unset challenge_token
470   echo " + Done!"
471 }
472
473 # Create certificate for domain(s)
474 sign_domain() {
475   domain="${1}"
476   altnames="${*}"
477   timestamp="$(date +%s)"
478
479   echo " + Signing domains..."
480   if [[ -z "${CA_NEW_AUTHZ}" ]] || [[ -z "${CA_NEW_CERT}" ]]; then
481     _exiterr "Certificate authority doesn't allow certificate signing"
482   fi
483
484   # If there is no existing certificate directory => make it
485   if [[ ! -e "${BASEDIR}/certs/${domain}" ]]; then
486     echo " + Creating new directory ${BASEDIR}/certs/${domain} ..."
487     mkdir -p "${BASEDIR}/certs/${domain}"
488   fi
489
490   privkey="privkey.pem"
491   # generate a new private key if we need or want one
492   if [[ ! -r "${BASEDIR}/certs/${domain}/privkey.pem" ]] || [[ "${PRIVATE_KEY_RENEW}" = "yes" ]]; then
493     echo " + Generating private key..."
494     privkey="privkey-${timestamp}.pem"
495     case "${KEY_ALGO}" in
496       rsa) _openssl genrsa -out "${BASEDIR}/certs/${domain}/privkey-${timestamp}.pem" "${KEYSIZE}";;
497       prime256v1|secp384r1) _openssl ecparam -genkey -name "${KEY_ALGO}" -out "${BASEDIR}/certs/${domain}/privkey-${timestamp}.pem";;
498     esac
499   fi
500
501   # Generate signing request config and the actual signing request
502   echo " + Generating signing request..."
503   SAN=""
504   for altname in ${altnames}; do
505     SAN+="DNS:${altname}, "
506   done
507   SAN="${SAN%%, }"
508   local tmp_openssl_cnf
509   tmp_openssl_cnf="$(mktemp -t XXXXXX)"
510   cat "${OPENSSL_CNF}" > "${tmp_openssl_cnf}"
511   printf "[SAN]\nsubjectAltName=%s" "${SAN}" >> "${tmp_openssl_cnf}"
512   openssl req -new -sha256 -key "${BASEDIR}/certs/${domain}/${privkey}" -out "${BASEDIR}/certs/${domain}/cert-${timestamp}.csr" -subj "/CN=${domain}/" -reqexts SAN -config "${tmp_openssl_cnf}"
513   rm -f "${tmp_openssl_cnf}"
514
515   crt_path="${BASEDIR}/certs/${domain}/cert-${timestamp}.pem"
516   sign_csr "$(< "${BASEDIR}/certs/${domain}/cert-${timestamp}.csr" )" ${altnames} 3>"${crt_path}"
517
518   # Create fullchain.pem
519   echo " + Creating fullchain.pem..."
520   cat "${crt_path}" > "${BASEDIR}/certs/${domain}/fullchain-${timestamp}.pem"
521   http_request get "$(openssl x509 -in "${BASEDIR}/certs/${domain}/cert-${timestamp}.pem" -noout -text | grep 'CA Issuers - URI:' | cut -d':' -f2-)" > "${BASEDIR}/certs/${domain}/chain-${timestamp}.pem"
522   if ! grep -q "BEGIN CERTIFICATE" "${BASEDIR}/certs/${domain}/chain-${timestamp}.pem"; then
523     openssl x509 -in "${BASEDIR}/certs/${domain}/chain-${timestamp}.pem" -inform DER -out "${BASEDIR}/certs/${domain}/chain-${timestamp}.pem" -outform PEM
524   fi
525   cat "${BASEDIR}/certs/${domain}/chain-${timestamp}.pem" >> "${BASEDIR}/certs/${domain}/fullchain-${timestamp}.pem"
526
527   # Update symlinks
528   [[ "${privkey}" = "privkey.pem" ]] || ln -sf "privkey-${timestamp}.pem" "${BASEDIR}/certs/${domain}/privkey.pem"
529
530   ln -sf "chain-${timestamp}.pem" "${BASEDIR}/certs/${domain}/chain.pem"
531   ln -sf "fullchain-${timestamp}.pem" "${BASEDIR}/certs/${domain}/fullchain.pem"
532   ln -sf "cert-${timestamp}.csr" "${BASEDIR}/certs/${domain}/cert.csr"
533   ln -sf "cert-${timestamp}.pem" "${BASEDIR}/certs/${domain}/cert.pem"
534
535   # Wait for hook script to clean the challenge and to deploy cert if used
536   [[ -n "${HOOK}" ]] && "${HOOK}" "deploy_cert" "${domain}" "${BASEDIR}/certs/${domain}/privkey.pem" "${BASEDIR}/certs/${domain}/cert.pem" "${BASEDIR}/certs/${domain}/fullchain.pem" "${BASEDIR}/certs/${domain}/chain.pem" <&4 >&5 2>&6
537
538   unset challenge_token
539   echo " + Done!"
540 }
541
542 # Usage: --cron (-c)
543 # Description: Sign/renew non-existant/changed/expiring certificates.
544 command_sign_domains() {
545   init_system
546
547   if [[ -n "${PARAM_DOMAIN:-}" ]]; then
548     DOMAINS_TXT="$(mktemp -t XXXXXX)"
549     printf -- "${PARAM_DOMAIN}" > "${DOMAINS_TXT}"
550   elif [[ -e "${BASEDIR}/domains.txt" ]]; then
551     DOMAINS_TXT="${BASEDIR}/domains.txt"
552   else
553     _exiterr "domains.txt not found and --domain not given"
554   fi
555
556   # Generate certificates for all domains found in domains.txt. Check if existing certificate are about to expire
557   <"${DOMAINS_TXT}" _sed -e 's/^[[:space:]]*//g' -e 's/[[:space:]]*$//g' -e 's/[[:space:]]+/ /g' | (grep -vE '^(#|$)' || true) | while read -r line; do
558     domain="$(printf '%s\n' "${line}" | cut -d' ' -f1)"
559     morenames="$(printf '%s\n' "${line}" | cut -s -d' ' -f2-)"
560     cert="${BASEDIR}/certs/${domain}/cert.pem"
561
562     force_renew="${PARAM_FORCE:-no}"
563
564     if [[ -z "${morenames}" ]];then
565       echo "Processing ${domain}"
566     else
567       echo "Processing ${domain} with alternative names: ${morenames}"
568     fi
569
570     if [[ -e "${cert}" ]]; then
571       printf " + Checking domain name(s) of existing cert..."
572
573       certnames="$(openssl x509 -in "${cert}" -text -noout | grep DNS: | _sed 's/DNS://g' | tr -d ' ' | tr ',' '\n' | sort -u | tr '\n' ' ' | _sed 's/ $//')"
574       givennames="$(echo "${domain}" "${morenames}"| tr ' ' '\n' | sort -u | tr '\n' ' ' | _sed 's/ $//' | _sed 's/^ //')"
575
576       if [[ "${certnames}" = "${givennames}" ]]; then
577         echo " unchanged."
578       else
579         echo " changed!"
580         echo " + Domain name(s) are not matching!"
581         echo " + Names in old certificate: ${certnames}"
582         echo " + Configured names: ${givennames}"
583         echo " + Forcing renew."
584         force_renew="yes"
585       fi
586     fi
587
588     if [[ -e "${cert}" ]]; then
589       echo " + Checking expire date of existing cert..."
590       valid="$(openssl x509 -enddate -noout -in "${cert}" | cut -d= -f2- )"
591
592       printf " + Valid till %s " "${valid}"
593       if openssl x509 -checkend $((RENEW_DAYS * 86400)) -noout -in "${cert}"; then
594         printf "(Longer than %d days). " "${RENEW_DAYS}"
595         if [[ "${force_renew}" = "yes" ]]; then
596           echo "Ignoring because renew was forced!"
597         else
598           echo "Skipping!"
599           continue
600         fi
601       else
602         echo "(Less than ${RENEW_DAYS} days). Renewing!"
603       fi
604     fi
605
606     # shellcheck disable=SC2086
607     sign_domain ${line}
608   done
609
610   # remove temporary domains.txt file if used
611   [[ -n "${PARAM_DOMAIN:-}" ]] && rm -f "${DOMAINS_TXT}"
612
613   exit 0
614 }
615
616 # Usage: --signcsr (-s) path/to/csr.pem
617 # Description: Sign a given CSR, output CRT on stdout (advanced usage)
618 command_sign_csr() {
619   # redirect stdout to stderr
620   # leave stdout over at fd 3 to output the cert
621   exec 3>&1 1>&2
622
623   init_system
624
625   csrfile="${1}"
626   if [ ! -r "${csrfile}" ]; then
627     _exiterr "Could not read certificate signing request ${csrfile}"
628   fi
629
630   sign_csr "$(< "${csrfile}" )"
631
632   exit 0
633 }
634
635 # Usage: --revoke (-r) path/to/cert.pem
636 # Description: Revoke specified certificate
637 command_revoke() {
638   init_system
639
640   [[ -n "${CA_REVOKE_CERT}" ]] || _exiterr "Certificate authority doesn't allow certificate revocation."
641
642   cert="${1}"
643   if [[ -L "${cert}" ]]; then
644     # follow symlink and use real certificate name (so we move the real file and not the symlink at the end)
645     local link_target
646     link_target="$(readlink -n "${cert}")"
647     if [[ "${link_target}" =~ ^/ ]]; then
648       cert="${link_target}"
649     else
650       cert="$(dirname "${cert}")/${link_target}"
651     fi
652   fi
653   [[ -f "${cert}" ]] || _exiterr "Could not find certificate ${cert}"
654
655   echo "Revoking ${cert}"
656
657   cert64="$(openssl x509 -in "${cert}" -inform PEM -outform DER | urlbase64)"
658   response="$(signed_request "${CA_REVOKE_CERT}" '{"resource": "revoke-cert", "certificate": "'"${cert64}"'"}')"
659   # if there is a problem with our revoke request _request (via signed_request) will report this and "exit 1" out
660   # so if we are here, it is safe to assume the request was successful
661   echo " + Done."
662   echo " + Renaming certificate to ${cert}-revoked"
663   mv -f "${cert}" "${cert}-revoked"
664 }
665
666 # Usage: --cleanup (-gc)
667 # Description: Move unused certificate files to archive directory
668 command_cleanup() {
669   load_config
670
671   # Create global archive directory if not existant
672   if [[ ! -e "${BASEDIR}/archive" ]]; then
673     mkdir "${BASEDIR}/archive"
674   fi
675
676   # Loop over all certificate directories
677   for certdir in "${BASEDIR}/certs/"*; do
678     # Skip if entry is not a folder
679     [[ -d "${certdir}" ]] || continue
680
681     # Get certificate name
682     certname="$(basename "${certdir}")"
683
684     # Create certitifaces archive directory if not existant
685     archivedir="${BASEDIR}/archive/${certname}"
686     if [[ ! -e "${archivedir}" ]]; then
687       mkdir "${archivedir}"
688     fi
689
690     # Loop over file-types (certificates, keys, signing-requests, ...)
691     for filetype in cert.csr cert.pem chain.pem fullchain.pem privkey.pem; do
692       # Skip if symlink is broken
693       [[ -r "${certdir}/${filetype}" ]] || continue
694
695       # Look up current file in use
696       current="$(basename $(readlink "${certdir}/${filetype}"))"
697
698       # Split filetype into name and extension
699       filebase="$(echo "${filetype}" | cut -d. -f1)"
700       fileext="$(echo "${filetype}" | cut -d. -f2)"
701
702       # Loop over all files of this type
703       for file in "${certdir}/${filebase}-"*".${fileext}"; do
704         # Check if current file is in use, if unused move to archive directory
705         filename="$(basename "${file}")"
706         if [[ ! "${filename}" = "${current}" ]]; then
707           echo "Moving unused file to archive directory: ${certname}/$filename"
708           mv "${certdir}/${filename}" "${archivedir}/${filename}"
709         fi
710       done
711     done
712   done
713
714   exit 0
715 }
716
717 # Usage: --help (-h)
718 # Description: Show help text
719 command_help() {
720   printf "Usage: %s [-h] [command [argument]] [parameter [argument]] [parameter [argument]] ...\n\n" "${0}"
721   printf "Default command: help\n\n"
722   echo "Commands:"
723   grep -e '^[[:space:]]*# Usage:' -e '^[[:space:]]*# Description:' -e '^command_.*()[[:space:]]*{' "${0}" | while read -r usage; read -r description; read -r command; do
724     if [[ ! "${usage}" =~ Usage ]] || [[ ! "${description}" =~ Description ]] || [[ ! "${command}" =~ ^command_ ]]; then
725       _exiterr "Error generating help text."
726     fi
727     printf " %-32s %s\n" "${usage##"# Usage: "}" "${description##"# Description: "}"
728   done
729   printf -- "\nParameters:\n"
730   grep -E -e '^[[:space:]]*# PARAM_Usage:' -e '^[[:space:]]*# PARAM_Description:' "${0}" | while read -r usage; read -r description; do
731     if [[ ! "${usage}" =~ Usage ]] || [[ ! "${description}" =~ Description ]]; then
732       _exiterr "Error generating help text."
733     fi
734     printf " %-32s %s\n" "${usage##"# PARAM_Usage: "}" "${description##"# PARAM_Description: "}"
735   done
736 }
737
738 # Usage: --env (-e)
739 # Description: Output configuration variables for use in other scripts
740 command_env() {
741   echo "# letsencrypt.sh configuration"
742   load_config
743   typeset -p CA LICENSE CHALLENGETYPE HOOK HOOK_CHAIN RENEW_DAYS PRIVATE_KEY KEYSIZE WELLKNOWN PRIVATE_KEY_RENEW OPENSSL_CNF CONTACT_EMAIL LOCKFILE
744 }
745
746 # Main method (parses script arguments and calls command_* methods)
747 main() {
748   COMMAND=""
749   set_command() {
750     [[ -z "${COMMAND}" ]] || _exiterr "Only one command can be executed at a time. See help (-h) for more information."
751     COMMAND="${1}"
752   }
753
754   check_parameters() {
755     if [[ -z "${1:-}" ]]; then
756       echo "The specified command requires additional parameters. See help:" >&2
757       echo >&2
758       command_help >&2
759       exit 1
760     elif [[ "${1:0:1}" = "-" ]]; then
761       _exiterr "Invalid argument: ${1}"
762     fi
763   }
764
765   [[ -z "${@}" ]] && eval set -- "--help"
766
767   while (( ${#} )); do
768     case "${1}" in
769       --help|-h)
770         command_help
771         exit 0
772         ;;
773
774       --env|-e)
775         set_command env
776         ;;
777
778       --cron|-c)
779         set_command sign_domains
780         ;;
781
782       --signcsr|-s)
783         shift 1
784         set_command sign_csr
785         check_parameters "${1:-}"
786         PARAM_CSR="${1}"
787         ;;
788
789       --revoke|-r)
790         shift 1
791         set_command revoke
792         check_parameters "${1:-}"
793         PARAM_REVOKECERT="${1}"
794         ;;
795
796       --cleanup|-gc)
797         set_command cleanup
798         ;;
799
800       # PARAM_Usage: --domain (-d) domain.tld
801       # PARAM_Description: Use specified domain name(s) instead of domains.txt entry (one certificate!)
802       --domain|-d)
803         shift 1
804         check_parameters "${1:-}"
805         if [[ -z "${PARAM_DOMAIN:-}" ]]; then
806           PARAM_DOMAIN="${1}"
807         else
808           PARAM_DOMAIN="${PARAM_DOMAIN} ${1}"
809          fi
810         ;;
811
812
813       # PARAM_Usage: --force (-x)
814       # PARAM_Description: Force renew of certificate even if it is longer valid than value in RENEW_DAYS
815       --force|-x)
816         PARAM_FORCE="yes"
817         ;;
818
819       # PARAM_Usage: --privkey (-p) path/to/key.pem
820       # PARAM_Description: Use specified private key instead of account key (useful for revocation)
821       --privkey|-p)
822         shift 1
823         check_parameters "${1:-}"
824         PARAM_PRIVATE_KEY="${1}"
825         ;;
826
827       # PARAM_Usage: --config (-f) path/to/config.sh
828       # PARAM_Description: Use specified config file
829       --config|-f)
830         shift 1
831         check_parameters "${1:-}"
832         CONFIG="${1}"
833         ;;
834
835       # PARAM_Usage: --hook (-k) path/to/hook.sh
836       # PARAM_Description: Use specified script for hooks
837       --hook|-k)
838         shift 1
839         check_parameters "${1:-}"
840         PARAM_HOOK="${1}"
841         ;;
842
843       # PARAM_Usage: --challenge (-t) http-01|dns-01
844       # PARAM_Description: Which challenge should be used? Currently http-01 and dns-01 are supported
845       --challenge|-t)
846         shift 1
847         check_parameters "${1:-}"
848         PARAM_CHALLENGETYPE="${1}"
849         ;;
850
851       # PARAM_Usage: --algo (-a) rsa|prime256v1|secp384r1
852       # PARAM_Description: Which public key algorithm should be used? Supported: rsa, prime256v1 and secp384r1
853       --algo|-a)
854         shift 1
855         check_parameters "${1:-}"
856         PARAM_KEY_ALGO="${1}"
857         ;;
858
859       *)
860         echo "Unknown parameter detected: ${1}" >&2
861         echo >&2
862         command_help >&2
863         exit 1
864         ;;
865     esac
866
867     shift 1
868   done
869
870   case "${COMMAND}" in
871     env) command_env;;
872     sign_domains) command_sign_domains;;
873     sign_csr) command_sign_csr "${PARAM_CSR}";;
874     revoke) command_revoke "${PARAM_REVOKECERT}";;
875     cleanup) command_cleanup;;
876     *) command_help; exit 1;;
877   esac
878 }
879
880 # Determine OS type
881 OSTYPE="$(uname)"
882
883 # Check for missing dependencies
884 check_dependencies
885
886 # Run script
887 main "${@:-}"